import React from 'react';
import { PropsWithMetadata, noop } from '@highlight-ui/utils-commons';
import { ToastTheme, ToastVariant } from './types';
export declare type ToastProps = PropsWithMetadata<{
    /** A fragment with buttons that will be rendered at the bottom of the toast */
    actions?: React.ReactNode;
    /** Specify whether the toast should auto close after the duration time ends */
    autoClose?: boolean;
    /** The content of the toast */
    children: React.ReactNode;
    /** Allows providing a custom class name to the DIV element that contains the toast */
    className?: string;
    /** Duration in milliseconds that the toast remains visible */
    duration?: number;
    /** The ID of the toast */
    id?: string;
    /** Specify whether the toast is visible */
    isVisible?: boolean;
    /** A callback when the toast is closed */
    onClose?: typeof noop;
    /** A callback when the toast is opened */
    onOpen?: typeof noop;
    /** A callback when the user request the toast to be closed */
    onRequestToClose?: typeof noop;
    /** A callback when the user request the toast to be removed */
    onRequestToRemove?: typeof noop;
    /** Specify whether the close button should be rendered */
    showCloseButton?: boolean;
    /**
     * @deprecated This prop has been replaced by variant and will be removed in an upcoming release.
     */
    theme?: ToastTheme;
    /** Defines which variant of the Toast to render */
    variant?: ToastVariant;
}>;
declare const Toast: React.FC<ToastProps>;
export default Toast;
